
#ifndef _GAME_
#define _GAME_

//#include "Crole.h"
//#include "spot.h"
//#include "other.h"
#include "TextParser.h"
#include "global.h"

/* game state */
enum GAMESTATE
{
	system_menu,		//µĹ£ɵĻ䣬⽨
	playing_sys_menu,	//洢ȣȡȣ뿪Ϸ
	player_adven,		//ðգ·̸״̬Ʒ
	show_exits,			//ѡȥ
	talk_with_npc,		//ѡ˭̸
	attack_npc,			//ѡ񹥻˭
	watch_npc,			//ѡ۲˭
	player_state,		//Ҳ쿴״̬ܡƷ
	list_goods,			//гӵƷ
	list_skills,		//гӵеļ
	list_quest,			//鿴
	use_goods,
	use_skill,
	fighting,			//ս
	player_act,			//ֵж	
	list_free_item,		//гʰȡƷ
	pick_item,			//ȡƷ
	check_equipment,	//װ
	unequip_,			//жװ
	trading,			//
	buy_goods,
	sell_goods
};


class CGame
{
public:
	
	CGame( HANDLE );
	~CGame();
	void RunGame();	

	char * GetLogoBuffer() { return stLogoBuffer;}
	char * GetMapBuffer() { return stMapBuffer;	}
	

private:	
	
	bool LoadResFileName(const char* pstFileName, const char cHeadFlag);
	bool LoadSpotsData( const char * pstFileName, const char cHeadFlag );	//load spots data	
	bool LoadNpcsData( char * pstFileName, char cHeadFlag );	// load npc data
	bool LoadSkillsData ( const char * pstFileName, const char cHeadFlag);	//load skill data
	bool LoadGoodsData ( char * pstFileName, char cHeadFlag );	//load goods data
	bool LoadQuestData ( char * pstFileName, char cHeadFlag );	//װ
	bool LoadScripts( char * pstFileName, char cHeadFlag);	// load scripts	
    void LoadNickData( const char * pstFileName, const char cHeadFlag);
	
	bool ReadWholeTextFile( char * stFileName , char * stBuffer);
	void ShowBuffer(  char * stBuffer );
	
	bool FindScripts( short nScriptsID );	//find scripts whose id is identical to that given
	void RunScripts( short nScriptID );	// run scripts
	void ExecuteScriptLine( char * stScriptLine );
	void ReadSubString( char * stString, char * stSubString );	
	
	void SystemOut( const char * stOutString );
	void SystemHint ( const char * stHintString );
	void SystemWarning(const char * stWarningString);
	void SystemPause();	

	void PrintNpcs( short nSpotIndex );
	void PrintGoodsOfNpc( short nNpcIndex );

	void ShowNpcName( short nNpcIndex);
    void ShowNickName( short nNpcIndex);
    void ShowNpcState( short nNpcIndex);
    void UpdateNick(short nRoleIdx);
	void ShowNpcDetail(short nNpcIndex);
	void ShowNpcDetailX ( short nNpcIndex );	//show npcs
	void ShowSpotName( short nSpotIndex );
	void ShowSpotDetail( short nSpotIndex );
	void ShowSkillName( short nSkillIndex);
	void ShowSkillDetail ( short nSkillIndex );		//show specific skill 
	void ShowGoodsName( short nGoodsIndex );
	void ShowGoodsDetail ( short nGoodsIndex);
	void ShowQuests( bool bCompleted );
	void ShowEquipment( short nRoleIndex, short nLocation );

	bool LoadPlayerData( bool bNewGame );
	bool SavePlayerData();

	void InitFight( short nNpcIndex );
	void EndFight( short nNpcIndex );	//˭ʤ
	short DecideWhoAct();
	short UseWhichSkill( short nRoleIndex );
	void Act( short nRoleIndex, short nSkillIndex, short nEnemyIndex );
	void EscapeOut( short nRoleIndex, short nEnemyIndex);
	
	short Experience( short nRoleIndex, short nEnemyIndex );		//㾭
	void UpdateLevel( short nRoleIndex );							//
	short Damage( short nRoleIndex, short nEnemyIndex );			//˺
	void UpdateSkillLevel( short nRoleIndex, short nSkillIndex );	//¼ܵȼ
	void SkillLevelUp( short nRoleIndex, short nSkillIndex );
	short SkillDamage( short nRoleIndex, short nSkillIndex );		//˺
	short SkillMpCost( short nRoleIndex, short nSkillIndex );
	void Refresh( short nRoleIndex );	//ȫ

	bool AddNpc(short nSpotIndex, short nNpcIndex );
	bool RemoveNpc(short nSpotIndex, short nNpcIndex );
    void AddMoney(short nRoleIdx, short nMoney);
    bool DelMoney(short nRoleIdx, short nMoney);
	bool AddGoods( short nRoleIndex, short nGoodsIndex, bool bVisible );	//Ʒ
	bool RemoveGoods( short nRoleIndex, short nGoodsLocation, bool bVisible );	//ƳƷ
	short HaveGoods( short nRoleIndex, short nGoodsIndex );		//ǷĳƷ
    short NumOfGoods( short nRoleIdx, short nGoodsIdx);         //ӵĳƷ
	bool AddSkill( short nRoleIndex, short nSkillIndex );		//Ӽ
	bool HaveSkill( short nRoleIndex, short nSkillIndex );		//Ƿĳּ
	void LearnSkill ( short nRoleIndex, short nGoodsIndex);		//ѧϰ
	void Eat( short nRoleIndex, short nGoodsIndex );			//
	void Equip( short nRoleIndex, short nGoodsLocation );		//װ
	void UnEquip( short nRoleIndex, short nLocation );			//Ƴװ
	void UseGoods( short nRoleIndex, short nGoodsLocation );	//ʹƷ
	void PickGoods( short nRoleIndex, short nGoodsLocation );	//
	void RmGoodsFromSpot( short nSpotIndex, short nGoodsLocation );
	void AddGoodsToSpot( short nSpotIndex, short nGoodsIndex );
    void RandomDrop( short nRoleIdx, short nGoodsIdx, short nProb);
	void BuyGoods( short nRoleIndex, short nGoodsIndex );
	void SellGoods( short nRoleIndex, short nGoodsLocation);

	short GetAddedAttack( short nRoleIndex );
	short GetAddedDefend( short nRoleIndex );
	short GetAddedSpeed( short nRoleIndex );

	short GetUserInput();	
	short GetUserInput( short nMin, short nMax );

private:
    bool iRunning;
    bool iRunningScripts;
	short nSpotsNum;
	short nNpcsNum;
	short nSkillsNum;
	short nGoodsNum;
	short nQuestsNum;
	HANDLE hConsoleHandle;

	CScriptLine * pScripts;
	CQuest * pQuests;
	CRole * pNpcs;
	CSpot * pSpots;
	CSkill * pSkills;
	CGoods * pGoods;
	//CRole	oPlayer;	//0npc 

	short nScriptsNumber;
	short nScriptLineNumber;	//script lines' number
	short nCurLineIndex;		//current scripts Index
	short nIndexInCurLine;		// the index in current script line

	struct CGameEnvironment 
	{	
		short nCurrentMap;			//current map index
		short nCurrentNpc;
		short nCurrentEnemy;
		short nCurrentSkill;
		short nCurrentGoods;
		short nCurrentEquipment;
		bool bFighting;
		GAMESTATE eState;			//game state

	}	oGameEnv;
	
	//򶷵ʱ
	struct CActSlot
	{
		short nRoleID;
		short nVirtualSpeed;
	} oActSlot[2];	
	
	//Դļ
	struct CResFiles
	{
		char stSkillFile[128];
		char stGoodsFile[128];
		char stRoleFile[128];
		char stSpotFile[128];
		char stQuestFile[128];
		char stScriptFile[128];
		char stMapFile[128];
		char stLogoFile[128];
        char stNickFile[128];

	} oResFiles;
	
	char stLogoBuffer[2048];
	char stMapBuffer[1024];

    char stSkillNicks[SKILL_KIND][16];
    char stLvlNicks[SKILL_LVL][16];
    short nNickExp[SKILL_LVL];

    //ṩ32ʹ
    short nVars[VAR_NUM];
};

#endif
